//**************HORNO DE INDUCCION **** RAMPAMAT ***********************

#include "stm32f1xx_hal.h"
#include "cmsis_os.h"


#include "hornoinduccion.h"


uint16_t TIM1_Preescalar=9;//63+1  **ahora es calculado automatico
uint16_t TIM1_Periodo=639;//99+1  **ahora es calculado automatico
uint8_t TIM1_Tmuerto=255; //      ** depende de la frecuencia para el pwm
uint32_t TIM1_Fre=100;// frecuencia inicial;

TIM_HandleTypeDef htim1;
//TIM_OC_InitTypeDef sConfigOC;
TIM_OC_InitTypeDef sConfigOC;
TIM_BreakDeadTimeConfigTypeDef sBreakDeadTimeConfig;


void HAL_TIM_Base_MspInit(TIM_HandleTypeDef* htim_base)
{

  if(htim_base->Instance==TIM1)  {
  
    __HAL_RCC_TIM1_CLK_ENABLE();
  
  }

}


void HAL_TIM_MspPostInit(TIM_HandleTypeDef* htim)
{

  GPIO_InitTypeDef GPIO_InitStruct;
	
	
  if(htim->Instance==TIM1)  {
    
    /**TIM1 GPIO Configuracion.................   
    PA7     ------> TIM1_CH1N
		PB0     ------> TIM1_CH2N
    PA8     ------> TIM1_CH1
		PA9     ------> TIM1_CH2 
		
    */
    GPIO_InitStruct.Pin = GPIO_PIN_7|GPIO_PIN_8|GPIO_PIN_9;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
    HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

		
    GPIO_InitStruct.Pin = GPIO_PIN_0;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
    HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);
		
    __HAL_AFIO_REMAP_TIM1_PARTIAL();
		
		
		
		

 
  }

}


void HAL_TIM_Base_MspDeInit(TIM_HandleTypeDef* htim_base)
{

  if(htim_base->Instance==TIM1)  {
  
    __HAL_RCC_TIM1_CLK_DISABLE();
  }
 

}


 void TIM1_Init(void){

  TIM_ClockConfigTypeDef sClockSourceConfig;
  TIM_MasterConfigTypeDef sMasterConfig;
  //TIM_OC_InitTypeDef sConfigOC;
  //TIM_BreakDeadTimeConfigTypeDef sBreakDeadTimeConfig;
	 
	
	
	 

  htim1.Instance = TIM1;
  htim1.Init.Prescaler = TIM1_Preescalar;
  htim1.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim1.Init.Period = TIM1_Periodo;
  htim1.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim1.Init.RepetitionCounter = 0;
  if (HAL_TIM_Base_Init(&htim1) != HAL_OK)  {
    Error_Handler();
  }
	
	HAL_TIM_MspPostInit(&htim1);//ojojoj
	

  sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_INTERNAL;
  if (HAL_TIM_ConfigClockSource(&htim1, &sClockSourceConfig) != HAL_OK)  {
    Error_Handler();
  }

	
  if (HAL_TIM_PWM_Init(&htim1) != HAL_OK)  {
    Error_Handler();
  }

	
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim1, &sMasterConfig) != HAL_OK)  {
    Error_Handler();
  }
	

  sConfigOC.OCMode = TIM_OCMODE_PWM1;
	
  sConfigOC.Pulse = TIM1_Periodo/2;//639/2;
  sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
  sConfigOC.OCNPolarity = TIM_OCNPOLARITY_HIGH;
  sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
  sConfigOC.OCIdleState = TIM_OCIDLESTATE_SET;
  sConfigOC.OCNIdleState = TIM_OCNIDLESTATE_SET;
	/*
	if (HAL_TIM_OC_Init(&htim1) != HAL_OK)  {
    Error_Handler();
  }
	*/
  if (HAL_TIM_PWM_ConfigChannel(&htim1, &sConfigOC, TIM_CHANNEL_1) != HAL_OK)  {
    Error_Handler();
  }

  if (HAL_TIM_PWM_ConfigChannel(&htim1, &sConfigOC, TIM_CHANNEL_2) != HAL_OK)  {
    Error_Handler();
  }

  sBreakDeadTimeConfig.OffStateRunMode = TIM_OSSR_ENABLE;
  sBreakDeadTimeConfig.OffStateIDLEMode = TIM_OSSI_ENABLE;
  sBreakDeadTimeConfig.LockLevel = TIM_LOCKLEVEL_OFF;
  sBreakDeadTimeConfig.DeadTime =TIM1_Tmuerto;
  sBreakDeadTimeConfig.BreakState = TIM_BREAK_DISABLE;
  sBreakDeadTimeConfig.BreakPolarity = TIM_BREAKPOLARITY_HIGH;
  sBreakDeadTimeConfig.AutomaticOutput = TIM_AUTOMATICOUTPUT_ENABLE;
  if (HAL_TIMEx_ConfigBreakDeadTime(&htim1, &sBreakDeadTimeConfig) != HAL_OK)  {
    Error_Handler();
  }

  //HAL_TIM_MspPostInit(&htim1);
	
	/*
	HAL_NVIC_SetPriority(TIM1_TRG_COM_IRQn, 0, 1);
  HAL_NVIC_EnableIRQ(TIM1_TRG_COM_IRQn);
	
	HAL_TIMEx_ConfigCommutationEvent_IT(&htim1, TIM_TS_NONE, TIM_COMMUTATION_SOFTWARE);
	
	HAL_TIM_OC_Start(&htim1, TIM_CHANNEL_1);
  
  HAL_TIMEx_OCN_Start(&htim1, TIM_CHANNEL_1);
	*/
	/*
	HAL_TIM_PWM_Start(&htim1,TIM_CHANNEL_1);
	HAL_TIMEx_PWMN_Start(&htim1,TIM_CHANNEL_1);
	
	HAL_TIM_PWM_Start(&htim1,TIM_CHANNEL_2);
	HAL_TIMEx_PWMN_Start(&htim1,TIM_CHANNEL_2);
	*/
	
}

/*
void HAL_TIMEx_CommutationCallback(TIM_HandleTypeDef *htim){
	
	HAL_TIM_PWM_Start(&htim1, TIM_CHANNEL_1);
}

*/


uint8_t Horno_Pase_Frecuencia(uint32_t fre,uint16_t *Per,uint16_t *Pre,uint8_t *Tmuerto){
	
	uint16_t per,pre;
	uint8_t tmu;
	uint8_t sal=0;
	
	//fre=*Fre;
	per=*Per;
	pre=*Pre;
	tmu=*Tmuerto;
	
	pre=999;
	
	while(1){
		per=(SystemCoreClock)/(fre*(pre+1));
		if(per>=100 && per<=64000) break;
		else{
			if(per<100){
				if(pre<=100)pre--;
				else pre-=100;
			}
			if(per>64000) pre+=100;
		}
		
	}
	
	
	if(fre>=100 && fre<1000){
		if(*Tmuerto!=255){
			tmu=255;
			sal=1;
			
			
		}
	}
	else if(fre>=1000 && fre<5000){
		if(*Tmuerto!=240){
			tmu=240;
			sal=1;
		}
	}
	else if(fre>=5000 && fre<10000){
		if(*Tmuerto!=210){
			tmu=210;
			sal=1;
		}
	}
	else if(fre>=10000 && fre<15000){
		if(*Tmuerto!=180){
			tmu=180;//100;
			sal=1;
		}
	}
	else if(fre>=15000 && fre <30000){
		if(*Tmuerto!=150){
			tmu=150;
			sal=1;
		}
	}
	else if(fre>=30000 && fre<60000){
		if(*Tmuerto!=120){
			tmu=120;
			sal=1;
		}
	}
	else if(fre>=60000 && fre<=120000){//fin
		if(*Tmuerto!=90){
			tmu=90;
			sal=1;
		}
	}
	else tmu=255;
	
	
	
	*Per=per-1;
	*Pre=pre;
	*Tmuerto=tmu;
	return sal;
}

void Horno_CambioFrecuencia(uint32_t fre,uint8_t divpwm){
	uint8_t ctm=0;
	TIM1_Fre=fre;
			
	
	ctm=Horno_Pase_Frecuencia(TIM1_Fre,&TIM1_Periodo,&TIM1_Preescalar,&TIM1_Tmuerto);
	/*
	htim1.Instance->PSC=TIM1_Preescalar;
	htim1.Instance->ARR=TIM1_Periodo;;
	htim1.Instance->DIER=TIM1_Tmuerto;
	*/
	
	__HAL_TIM_GET_AUTORELOAD(&htim1);
	__HAL_TIM_SET_PRESCALER(&htim1,TIM1_Preescalar);
	__HAL_TIM_SET_AUTORELOAD(&htim1,TIM1_Periodo);
	
	htim1.Instance->DIER=TIM1_Tmuerto;
	
	
	
	if (HAL_TIMEx_ConfigBreakDeadTime(&htim1, &sBreakDeadTimeConfig) != HAL_OK)  {
    Error_Handler();
  }
	
	if(ctm==1){
		HAL_TIM_PWM_Stop(&htim1,TIM_CHANNEL_1);
		HAL_TIM_PWM_Stop(&htim1,TIM_CHANNEL_2);
		HAL_TIMEx_PWMN_Stop(&htim1,TIM_CHANNEL_1);
		HAL_TIMEx_PWMN_Stop(&htim1,TIM_CHANNEL_2);
		

	}
	
	__HAL_TIM_SET_COMPARE(&htim1,TIM_CHANNEL_1,TIM1_Periodo/divpwm);
	__HAL_TIM_SET_COMPARE(&htim1,TIM_CHANNEL_2,TIM1_Periodo/divpwm);
	
	
	if(ctm==1){
		TIM1_Init();
		

	}
}



void Horno_Activar(void){
	HAL_TIM_PWM_Start(&htim1,TIM_CHANNEL_1);
	HAL_TIMEx_PWMN_Start(&htim1,TIM_CHANNEL_1);
	
	HAL_TIM_PWM_Start(&htim1,TIM_CHANNEL_2);
	HAL_TIMEx_PWMN_Start(&htim1,TIM_CHANNEL_2);
	
}

void Horno_Desactivar(void){
	HAL_TIM_PWM_Stop(&htim1,TIM_CHANNEL_1);
	HAL_TIM_PWM_Stop(&htim1,TIM_CHANNEL_2);
	HAL_TIMEx_PWMN_Stop(&htim1,TIM_CHANNEL_1);
	HAL_TIMEx_PWMN_Stop(&htim1,TIM_CHANNEL_2);
		
}




		
		





